package com.emr.entity;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class ArchiveOtherExtExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public ArchiveOtherExtExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("ID is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("ID is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Long value) {
            addCriterion("ID =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Long value) {
            addCriterion("ID <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Long value) {
            addCriterion("ID >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Long value) {
            addCriterion("ID >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Long value) {
            addCriterion("ID <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Long value) {
            addCriterion("ID <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Long> values) {
            addCriterion("ID in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Long> values) {
            addCriterion("ID not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Long value1, Long value2) {
            addCriterion("ID between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Long value1, Long value2) {
            addCriterion("ID not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andSyctimeIsNull() {
            addCriterion("SycTime is null");
            return (Criteria) this;
        }

        public Criteria andSyctimeIsNotNull() {
            addCriterion("SycTime is not null");
            return (Criteria) this;
        }

        public Criteria andSyctimeEqualTo(Date value) {
            addCriterion("SycTime =", value, "syctime");
            return (Criteria) this;
        }

        public Criteria andSyctimeNotEqualTo(Date value) {
            addCriterion("SycTime <>", value, "syctime");
            return (Criteria) this;
        }

        public Criteria andSyctimeGreaterThan(Date value) {
            addCriterion("SycTime >", value, "syctime");
            return (Criteria) this;
        }

        public Criteria andSyctimeGreaterThanOrEqualTo(Date value) {
            addCriterion("SycTime >=", value, "syctime");
            return (Criteria) this;
        }

        public Criteria andSyctimeLessThan(Date value) {
            addCriterion("SycTime <", value, "syctime");
            return (Criteria) this;
        }

        public Criteria andSyctimeLessThanOrEqualTo(Date value) {
            addCriterion("SycTime <=", value, "syctime");
            return (Criteria) this;
        }

        public Criteria andSyctimeIn(List<Date> values) {
            addCriterion("SycTime in", values, "syctime");
            return (Criteria) this;
        }

        public Criteria andSyctimeNotIn(List<Date> values) {
            addCriterion("SycTime not in", values, "syctime");
            return (Criteria) this;
        }

        public Criteria andSyctimeBetween(Date value1, Date value2) {
            addCriterion("SycTime between", value1, value2, "syctime");
            return (Criteria) this;
        }

        public Criteria andSyctimeNotBetween(Date value1, Date value2) {
            addCriterion("SycTime not between", value1, value2, "syctime");
            return (Criteria) this;
        }

        public Criteria andSycobjIsNull() {
            addCriterion("SycObj is null");
            return (Criteria) this;
        }

        public Criteria andSycobjIsNotNull() {
            addCriterion("SycObj is not null");
            return (Criteria) this;
        }

        public Criteria andSycobjEqualTo(String value) {
            addCriterion("SycObj =", value, "sycobj");
            return (Criteria) this;
        }

        public Criteria andSycobjNotEqualTo(String value) {
            addCriterion("SycObj <>", value, "sycobj");
            return (Criteria) this;
        }

        public Criteria andSycobjGreaterThan(String value) {
            addCriterion("SycObj >", value, "sycobj");
            return (Criteria) this;
        }

        public Criteria andSycobjGreaterThanOrEqualTo(String value) {
            addCriterion("SycObj >=", value, "sycobj");
            return (Criteria) this;
        }

        public Criteria andSycobjLessThan(String value) {
            addCriterion("SycObj <", value, "sycobj");
            return (Criteria) this;
        }

        public Criteria andSycobjLessThanOrEqualTo(String value) {
            addCriterion("SycObj <=", value, "sycobj");
            return (Criteria) this;
        }

        public Criteria andSycobjLike(String value) {
            addCriterion("SycObj like", value, "sycobj");
            return (Criteria) this;
        }

        public Criteria andSycobjNotLike(String value) {
            addCriterion("SycObj not like", value, "sycobj");
            return (Criteria) this;
        }

        public Criteria andSycobjIn(List<String> values) {
            addCriterion("SycObj in", values, "sycobj");
            return (Criteria) this;
        }

        public Criteria andSycobjNotIn(List<String> values) {
            addCriterion("SycObj not in", values, "sycobj");
            return (Criteria) this;
        }

        public Criteria andSycobjBetween(String value1, String value2) {
            addCriterion("SycObj between", value1, value2, "sycobj");
            return (Criteria) this;
        }

        public Criteria andSycobjNotBetween(String value1, String value2) {
            addCriterion("SycObj not between", value1, value2, "sycobj");
            return (Criteria) this;
        }

        public Criteria andOtheridIsNull() {
            addCriterion("otherID is null");
            return (Criteria) this;
        }

        public Criteria andOtheridIsNotNull() {
            addCriterion("otherID is not null");
            return (Criteria) this;
        }

        public Criteria andOtheridEqualTo(Long value) {
            addCriterion("otherID =", value, "otherid");
            return (Criteria) this;
        }

        public Criteria andOtheridNotEqualTo(Long value) {
            addCriterion("otherID <>", value, "otherid");
            return (Criteria) this;
        }

        public Criteria andOtheridGreaterThan(Long value) {
            addCriterion("otherID >", value, "otherid");
            return (Criteria) this;
        }

        public Criteria andOtheridGreaterThanOrEqualTo(Long value) {
            addCriterion("otherID >=", value, "otherid");
            return (Criteria) this;
        }

        public Criteria andOtheridLessThan(Long value) {
            addCriterion("otherID <", value, "otherid");
            return (Criteria) this;
        }

        public Criteria andOtheridLessThanOrEqualTo(Long value) {
            addCriterion("otherID <=", value, "otherid");
            return (Criteria) this;
        }

        public Criteria andOtheridIn(List<Long> values) {
            addCriterion("otherID in", values, "otherid");
            return (Criteria) this;
        }

        public Criteria andOtheridNotIn(List<Long> values) {
            addCriterion("otherID not in", values, "otherid");
            return (Criteria) this;
        }

        public Criteria andOtheridBetween(Long value1, Long value2) {
            addCriterion("otherID between", value1, value2, "otherid");
            return (Criteria) this;
        }

        public Criteria andOtheridNotBetween(Long value1, Long value2) {
            addCriterion("otherID not between", value1, value2, "otherid");
            return (Criteria) this;
        }

        public Criteria andSysflagIsNull() {
            addCriterion("sysFlag is null");
            return (Criteria) this;
        }

        public Criteria andSysflagIsNotNull() {
            addCriterion("sysFlag is not null");
            return (Criteria) this;
        }

        public Criteria andSysflagEqualTo(Integer value) {
            addCriterion("sysFlag =", value, "sysflag");
            return (Criteria) this;
        }

        public Criteria andSysflagNotEqualTo(Integer value) {
            addCriterion("sysFlag <>", value, "sysflag");
            return (Criteria) this;
        }

        public Criteria andSysflagGreaterThan(Integer value) {
            addCriterion("sysFlag >", value, "sysflag");
            return (Criteria) this;
        }

        public Criteria andSysflagGreaterThanOrEqualTo(Integer value) {
            addCriterion("sysFlag >=", value, "sysflag");
            return (Criteria) this;
        }

        public Criteria andSysflagLessThan(Integer value) {
            addCriterion("sysFlag <", value, "sysflag");
            return (Criteria) this;
        }

        public Criteria andSysflagLessThanOrEqualTo(Integer value) {
            addCriterion("sysFlag <=", value, "sysflag");
            return (Criteria) this;
        }

        public Criteria andSysflagIn(List<Integer> values) {
            addCriterion("sysFlag in", values, "sysflag");
            return (Criteria) this;
        }

        public Criteria andSysflagNotIn(List<Integer> values) {
            addCriterion("sysFlag not in", values, "sysflag");
            return (Criteria) this;
        }

        public Criteria andSysflagBetween(Integer value1, Integer value2) {
            addCriterion("sysFlag between", value1, value2, "sysflag");
            return (Criteria) this;
        }

        public Criteria andSysflagNotBetween(Integer value1, Integer value2) {
            addCriterion("sysFlag not between", value1, value2, "sysflag");
            return (Criteria) this;
        }

        public Criteria andSysupdatetimeIsNull() {
            addCriterion("sysUpdateTime is null");
            return (Criteria) this;
        }

        public Criteria andSysupdatetimeIsNotNull() {
            addCriterion("sysUpdateTime is not null");
            return (Criteria) this;
        }

        public Criteria andSysupdatetimeEqualTo(Date value) {
            addCriterion("sysUpdateTime =", value, "sysupdatetime");
            return (Criteria) this;
        }

        public Criteria andSysupdatetimeNotEqualTo(Date value) {
            addCriterion("sysUpdateTime <>", value, "sysupdatetime");
            return (Criteria) this;
        }

        public Criteria andSysupdatetimeGreaterThan(Date value) {
            addCriterion("sysUpdateTime >", value, "sysupdatetime");
            return (Criteria) this;
        }

        public Criteria andSysupdatetimeGreaterThanOrEqualTo(Date value) {
            addCriterion("sysUpdateTime >=", value, "sysupdatetime");
            return (Criteria) this;
        }

        public Criteria andSysupdatetimeLessThan(Date value) {
            addCriterion("sysUpdateTime <", value, "sysupdatetime");
            return (Criteria) this;
        }

        public Criteria andSysupdatetimeLessThanOrEqualTo(Date value) {
            addCriterion("sysUpdateTime <=", value, "sysupdatetime");
            return (Criteria) this;
        }

        public Criteria andSysupdatetimeIn(List<Date> values) {
            addCriterion("sysUpdateTime in", values, "sysupdatetime");
            return (Criteria) this;
        }

        public Criteria andSysupdatetimeNotIn(List<Date> values) {
            addCriterion("sysUpdateTime not in", values, "sysupdatetime");
            return (Criteria) this;
        }

        public Criteria andSysupdatetimeBetween(Date value1, Date value2) {
            addCriterion("sysUpdateTime between", value1, value2, "sysupdatetime");
            return (Criteria) this;
        }

        public Criteria andSysupdatetimeNotBetween(Date value1, Date value2) {
            addCriterion("sysUpdateTime not between", value1, value2, "sysupdatetime");
            return (Criteria) this;
        }

        public Criteria andJzhIsNull() {
            addCriterion("jzh is null");
            return (Criteria) this;
        }

        public Criteria andJzhIsNotNull() {
            addCriterion("jzh is not null");
            return (Criteria) this;
        }

        public Criteria andJzhEqualTo(String value) {
            addCriterion("jzh =", value, "jzh");
            return (Criteria) this;
        }

        public Criteria andJzhNotEqualTo(String value) {
            addCriterion("jzh <>", value, "jzh");
            return (Criteria) this;
        }

        public Criteria andJzhGreaterThan(String value) {
            addCriterion("jzh >", value, "jzh");
            return (Criteria) this;
        }

        public Criteria andJzhGreaterThanOrEqualTo(String value) {
            addCriterion("jzh >=", value, "jzh");
            return (Criteria) this;
        }

        public Criteria andJzhLessThan(String value) {
            addCriterion("jzh <", value, "jzh");
            return (Criteria) this;
        }

        public Criteria andJzhLessThanOrEqualTo(String value) {
            addCriterion("jzh <=", value, "jzh");
            return (Criteria) this;
        }

        public Criteria andJzhLike(String value) {
            addCriterion("jzh like", value, "jzh");
            return (Criteria) this;
        }

        public Criteria andJzhNotLike(String value) {
            addCriterion("jzh not like", value, "jzh");
            return (Criteria) this;
        }

        public Criteria andJzhIn(List<String> values) {
            addCriterion("jzh in", values, "jzh");
            return (Criteria) this;
        }

        public Criteria andJzhNotIn(List<String> values) {
            addCriterion("jzh not in", values, "jzh");
            return (Criteria) this;
        }

        public Criteria andJzhBetween(String value1, String value2) {
            addCriterion("jzh between", value1, value2, "jzh");
            return (Criteria) this;
        }

        public Criteria andJzhNotBetween(String value1, String value2) {
            addCriterion("jzh not between", value1, value2, "jzh");
            return (Criteria) this;
        }

        public Criteria andZyhIsNull() {
            addCriterion("zyh is null");
            return (Criteria) this;
        }

        public Criteria andZyhIsNotNull() {
            addCriterion("zyh is not null");
            return (Criteria) this;
        }

        public Criteria andZyhEqualTo(String value) {
            addCriterion("zyh =", value, "zyh");
            return (Criteria) this;
        }

        public Criteria andZyhNotEqualTo(String value) {
            addCriterion("zyh <>", value, "zyh");
            return (Criteria) this;
        }

        public Criteria andZyhGreaterThan(String value) {
            addCriterion("zyh >", value, "zyh");
            return (Criteria) this;
        }

        public Criteria andZyhGreaterThanOrEqualTo(String value) {
            addCriterion("zyh >=", value, "zyh");
            return (Criteria) this;
        }

        public Criteria andZyhLessThan(String value) {
            addCriterion("zyh <", value, "zyh");
            return (Criteria) this;
        }

        public Criteria andZyhLessThanOrEqualTo(String value) {
            addCriterion("zyh <=", value, "zyh");
            return (Criteria) this;
        }

        public Criteria andZyhLike(String value) {
            addCriterion("zyh like", value, "zyh");
            return (Criteria) this;
        }

        public Criteria andZyhNotLike(String value) {
            addCriterion("zyh not like", value, "zyh");
            return (Criteria) this;
        }

        public Criteria andZyhIn(List<String> values) {
            addCriterion("zyh in", values, "zyh");
            return (Criteria) this;
        }

        public Criteria andZyhNotIn(List<String> values) {
            addCriterion("zyh not in", values, "zyh");
            return (Criteria) this;
        }

        public Criteria andZyhBetween(String value1, String value2) {
            addCriterion("zyh between", value1, value2, "zyh");
            return (Criteria) this;
        }

        public Criteria andZyhNotBetween(String value1, String value2) {
            addCriterion("zyh not between", value1, value2, "zyh");
            return (Criteria) this;
        }

        public Criteria andStimeIsNull() {
            addCriterion("stime is null");
            return (Criteria) this;
        }

        public Criteria andStimeIsNotNull() {
            addCriterion("stime is not null");
            return (Criteria) this;
        }

        public Criteria andStimeEqualTo(Date value) {
            addCriterion("stime =", value, "stime");
            return (Criteria) this;
        }

        public Criteria andStimeNotEqualTo(Date value) {
            addCriterion("stime <>", value, "stime");
            return (Criteria) this;
        }

        public Criteria andStimeGreaterThan(Date value) {
            addCriterion("stime >", value, "stime");
            return (Criteria) this;
        }

        public Criteria andStimeGreaterThanOrEqualTo(Date value) {
            addCriterion("stime >=", value, "stime");
            return (Criteria) this;
        }

        public Criteria andStimeLessThan(Date value) {
            addCriterion("stime <", value, "stime");
            return (Criteria) this;
        }

        public Criteria andStimeLessThanOrEqualTo(Date value) {
            addCriterion("stime <=", value, "stime");
            return (Criteria) this;
        }

        public Criteria andStimeIn(List<Date> values) {
            addCriterion("stime in", values, "stime");
            return (Criteria) this;
        }

        public Criteria andStimeNotIn(List<Date> values) {
            addCriterion("stime not in", values, "stime");
            return (Criteria) this;
        }

        public Criteria andStimeBetween(Date value1, Date value2) {
            addCriterion("stime between", value1, value2, "stime");
            return (Criteria) this;
        }

        public Criteria andStimeNotBetween(Date value1, Date value2) {
            addCriterion("stime not between", value1, value2, "stime");
            return (Criteria) this;
        }

        public Criteria andEtimeIsNull() {
            addCriterion("eTime is null");
            return (Criteria) this;
        }

        public Criteria andEtimeIsNotNull() {
            addCriterion("eTime is not null");
            return (Criteria) this;
        }

        public Criteria andEtimeEqualTo(Date value) {
            addCriterion("eTime =", value, "etime");
            return (Criteria) this;
        }

        public Criteria andEtimeNotEqualTo(Date value) {
            addCriterion("eTime <>", value, "etime");
            return (Criteria) this;
        }

        public Criteria andEtimeGreaterThan(Date value) {
            addCriterion("eTime >", value, "etime");
            return (Criteria) this;
        }

        public Criteria andEtimeGreaterThanOrEqualTo(Date value) {
            addCriterion("eTime >=", value, "etime");
            return (Criteria) this;
        }

        public Criteria andEtimeLessThan(Date value) {
            addCriterion("eTime <", value, "etime");
            return (Criteria) this;
        }

        public Criteria andEtimeLessThanOrEqualTo(Date value) {
            addCriterion("eTime <=", value, "etime");
            return (Criteria) this;
        }

        public Criteria andEtimeIn(List<Date> values) {
            addCriterion("eTime in", values, "etime");
            return (Criteria) this;
        }

        public Criteria andEtimeNotIn(List<Date> values) {
            addCriterion("eTime not in", values, "etime");
            return (Criteria) this;
        }

        public Criteria andEtimeBetween(Date value1, Date value2) {
            addCriterion("eTime between", value1, value2, "etime");
            return (Criteria) this;
        }

        public Criteria andEtimeNotBetween(Date value1, Date value2) {
            addCriterion("eTime not between", value1, value2, "etime");
            return (Criteria) this;
        }

        public Criteria andStatusflagIsNull() {
            addCriterion("statusFlag is null");
            return (Criteria) this;
        }

        public Criteria andStatusflagIsNotNull() {
            addCriterion("statusFlag is not null");
            return (Criteria) this;
        }

        public Criteria andStatusflagEqualTo(Integer value) {
            addCriterion("statusFlag =", value, "statusflag");
            return (Criteria) this;
        }

        public Criteria andStatusflagNotEqualTo(Integer value) {
            addCriterion("statusFlag <>", value, "statusflag");
            return (Criteria) this;
        }

        public Criteria andStatusflagGreaterThan(Integer value) {
            addCriterion("statusFlag >", value, "statusflag");
            return (Criteria) this;
        }

        public Criteria andStatusflagGreaterThanOrEqualTo(Integer value) {
            addCriterion("statusFlag >=", value, "statusflag");
            return (Criteria) this;
        }

        public Criteria andStatusflagLessThan(Integer value) {
            addCriterion("statusFlag <", value, "statusflag");
            return (Criteria) this;
        }

        public Criteria andStatusflagLessThanOrEqualTo(Integer value) {
            addCriterion("statusFlag <=", value, "statusflag");
            return (Criteria) this;
        }

        public Criteria andStatusflagIn(List<Integer> values) {
            addCriterion("statusFlag in", values, "statusflag");
            return (Criteria) this;
        }

        public Criteria andStatusflagNotIn(List<Integer> values) {
            addCriterion("statusFlag not in", values, "statusflag");
            return (Criteria) this;
        }

        public Criteria andStatusflagBetween(Integer value1, Integer value2) {
            addCriterion("statusFlag between", value1, value2, "statusflag");
            return (Criteria) this;
        }

        public Criteria andStatusflagNotBetween(Integer value1, Integer value2) {
            addCriterion("statusFlag not between", value1, value2, "statusflag");
            return (Criteria) this;
        }

        public Criteria andPresultIsNull() {
            addCriterion("pResult is null");
            return (Criteria) this;
        }

        public Criteria andPresultIsNotNull() {
            addCriterion("pResult is not null");
            return (Criteria) this;
        }

        public Criteria andPresultEqualTo(String value) {
            addCriterion("pResult =", value, "presult");
            return (Criteria) this;
        }

        public Criteria andPresultNotEqualTo(String value) {
            addCriterion("pResult <>", value, "presult");
            return (Criteria) this;
        }

        public Criteria andPresultGreaterThan(String value) {
            addCriterion("pResult >", value, "presult");
            return (Criteria) this;
        }

        public Criteria andPresultGreaterThanOrEqualTo(String value) {
            addCriterion("pResult >=", value, "presult");
            return (Criteria) this;
        }

        public Criteria andPresultLessThan(String value) {
            addCriterion("pResult <", value, "presult");
            return (Criteria) this;
        }

        public Criteria andPresultLessThanOrEqualTo(String value) {
            addCriterion("pResult <=", value, "presult");
            return (Criteria) this;
        }

        public Criteria andPresultLike(String value) {
            addCriterion("pResult like", value, "presult");
            return (Criteria) this;
        }

        public Criteria andPresultNotLike(String value) {
            addCriterion("pResult not like", value, "presult");
            return (Criteria) this;
        }

        public Criteria andPresultIn(List<String> values) {
            addCriterion("pResult in", values, "presult");
            return (Criteria) this;
        }

        public Criteria andPresultNotIn(List<String> values) {
            addCriterion("pResult not in", values, "presult");
            return (Criteria) this;
        }

        public Criteria andPresultBetween(String value1, String value2) {
            addCriterion("pResult between", value1, value2, "presult");
            return (Criteria) this;
        }

        public Criteria andPresultNotBetween(String value1, String value2) {
            addCriterion("pResult not between", value1, value2, "presult");
            return (Criteria) this;
        }

        public Criteria andMidIsNull() {
            addCriterion("MID is null");
            return (Criteria) this;
        }

        public Criteria andMidIsNotNull() {
            addCriterion("MID is not null");
            return (Criteria) this;
        }

        public Criteria andMidEqualTo(String value) {
            addCriterion("MID =", value, "mid");
            return (Criteria) this;
        }

        public Criteria andMidNotEqualTo(String value) {
            addCriterion("MID <>", value, "mid");
            return (Criteria) this;
        }

        public Criteria andMidGreaterThan(String value) {
            addCriterion("MID >", value, "mid");
            return (Criteria) this;
        }

        public Criteria andMidGreaterThanOrEqualTo(String value) {
            addCriterion("MID >=", value, "mid");
            return (Criteria) this;
        }

        public Criteria andMidLessThan(String value) {
            addCriterion("MID <", value, "mid");
            return (Criteria) this;
        }

        public Criteria andMidLessThanOrEqualTo(String value) {
            addCriterion("MID <=", value, "mid");
            return (Criteria) this;
        }

        public Criteria andMidLike(String value) {
            addCriterion("MID like", value, "mid");
            return (Criteria) this;
        }

        public Criteria andMidNotLike(String value) {
            addCriterion("MID not like", value, "mid");
            return (Criteria) this;
        }

        public Criteria andMidIn(List<String> values) {
            addCriterion("MID in", values, "mid");
            return (Criteria) this;
        }

        public Criteria andMidNotIn(List<String> values) {
            addCriterion("MID not in", values, "mid");
            return (Criteria) this;
        }

        public Criteria andMidBetween(String value1, String value2) {
            addCriterion("MID between", value1, value2, "mid");
            return (Criteria) this;
        }

        public Criteria andMidNotBetween(String value1, String value2) {
            addCriterion("MID not between", value1, value2, "mid");
            return (Criteria) this;
        }

        public Criteria andDidIsNull() {
            addCriterion("DID is null");
            return (Criteria) this;
        }

        public Criteria andDidIsNotNull() {
            addCriterion("DID is not null");
            return (Criteria) this;
        }

        public Criteria andDidEqualTo(String value) {
            addCriterion("DID =", value, "did");
            return (Criteria) this;
        }

        public Criteria andDidNotEqualTo(String value) {
            addCriterion("DID <>", value, "did");
            return (Criteria) this;
        }

        public Criteria andDidGreaterThan(String value) {
            addCriterion("DID >", value, "did");
            return (Criteria) this;
        }

        public Criteria andDidGreaterThanOrEqualTo(String value) {
            addCriterion("DID >=", value, "did");
            return (Criteria) this;
        }

        public Criteria andDidLessThan(String value) {
            addCriterion("DID <", value, "did");
            return (Criteria) this;
        }

        public Criteria andDidLessThanOrEqualTo(String value) {
            addCriterion("DID <=", value, "did");
            return (Criteria) this;
        }

        public Criteria andDidLike(String value) {
            addCriterion("DID like", value, "did");
            return (Criteria) this;
        }

        public Criteria andDidNotLike(String value) {
            addCriterion("DID not like", value, "did");
            return (Criteria) this;
        }

        public Criteria andDidIn(List<String> values) {
            addCriterion("DID in", values, "did");
            return (Criteria) this;
        }

        public Criteria andDidNotIn(List<String> values) {
            addCriterion("DID not in", values, "did");
            return (Criteria) this;
        }

        public Criteria andDidBetween(String value1, String value2) {
            addCriterion("DID between", value1, value2, "did");
            return (Criteria) this;
        }

        public Criteria andDidNotBetween(String value1, String value2) {
            addCriterion("DID not between", value1, value2, "did");
            return (Criteria) this;
        }

        public Criteria andC1IsNull() {
            addCriterion("C1 is null");
            return (Criteria) this;
        }

        public Criteria andC1IsNotNull() {
            addCriterion("C1 is not null");
            return (Criteria) this;
        }

        public Criteria andC1EqualTo(String value) {
            addCriterion("C1 =", value, "c1");
            return (Criteria) this;
        }

        public Criteria andC1NotEqualTo(String value) {
            addCriterion("C1 <>", value, "c1");
            return (Criteria) this;
        }

        public Criteria andC1GreaterThan(String value) {
            addCriterion("C1 >", value, "c1");
            return (Criteria) this;
        }

        public Criteria andC1GreaterThanOrEqualTo(String value) {
            addCriterion("C1 >=", value, "c1");
            return (Criteria) this;
        }

        public Criteria andC1LessThan(String value) {
            addCriterion("C1 <", value, "c1");
            return (Criteria) this;
        }

        public Criteria andC1LessThanOrEqualTo(String value) {
            addCriterion("C1 <=", value, "c1");
            return (Criteria) this;
        }

        public Criteria andC1Like(String value) {
            addCriterion("C1 like", value, "c1");
            return (Criteria) this;
        }

        public Criteria andC1NotLike(String value) {
            addCriterion("C1 not like", value, "c1");
            return (Criteria) this;
        }

        public Criteria andC1In(List<String> values) {
            addCriterion("C1 in", values, "c1");
            return (Criteria) this;
        }

        public Criteria andC1NotIn(List<String> values) {
            addCriterion("C1 not in", values, "c1");
            return (Criteria) this;
        }

        public Criteria andC1Between(String value1, String value2) {
            addCriterion("C1 between", value1, value2, "c1");
            return (Criteria) this;
        }

        public Criteria andC1NotBetween(String value1, String value2) {
            addCriterion("C1 not between", value1, value2, "c1");
            return (Criteria) this;
        }

        public Criteria andC2IsNull() {
            addCriterion("C2 is null");
            return (Criteria) this;
        }

        public Criteria andC2IsNotNull() {
            addCriterion("C2 is not null");
            return (Criteria) this;
        }

        public Criteria andC2EqualTo(String value) {
            addCriterion("C2 =", value, "c2");
            return (Criteria) this;
        }

        public Criteria andC2NotEqualTo(String value) {
            addCriterion("C2 <>", value, "c2");
            return (Criteria) this;
        }

        public Criteria andC2GreaterThan(String value) {
            addCriterion("C2 >", value, "c2");
            return (Criteria) this;
        }

        public Criteria andC2GreaterThanOrEqualTo(String value) {
            addCriterion("C2 >=", value, "c2");
            return (Criteria) this;
        }

        public Criteria andC2LessThan(String value) {
            addCriterion("C2 <", value, "c2");
            return (Criteria) this;
        }

        public Criteria andC2LessThanOrEqualTo(String value) {
            addCriterion("C2 <=", value, "c2");
            return (Criteria) this;
        }

        public Criteria andC2Like(String value) {
            addCriterion("C2 like", value, "c2");
            return (Criteria) this;
        }

        public Criteria andC2NotLike(String value) {
            addCriterion("C2 not like", value, "c2");
            return (Criteria) this;
        }

        public Criteria andC2In(List<String> values) {
            addCriterion("C2 in", values, "c2");
            return (Criteria) this;
        }

        public Criteria andC2NotIn(List<String> values) {
            addCriterion("C2 not in", values, "c2");
            return (Criteria) this;
        }

        public Criteria andC2Between(String value1, String value2) {
            addCriterion("C2 between", value1, value2, "c2");
            return (Criteria) this;
        }

        public Criteria andC2NotBetween(String value1, String value2) {
            addCriterion("C2 not between", value1, value2, "c2");
            return (Criteria) this;
        }

        public Criteria andC3IsNull() {
            addCriterion("C3 is null");
            return (Criteria) this;
        }

        public Criteria andC3IsNotNull() {
            addCriterion("C3 is not null");
            return (Criteria) this;
        }

        public Criteria andC3EqualTo(String value) {
            addCriterion("C3 =", value, "c3");
            return (Criteria) this;
        }

        public Criteria andC3NotEqualTo(String value) {
            addCriterion("C3 <>", value, "c3");
            return (Criteria) this;
        }

        public Criteria andC3GreaterThan(String value) {
            addCriterion("C3 >", value, "c3");
            return (Criteria) this;
        }

        public Criteria andC3GreaterThanOrEqualTo(String value) {
            addCriterion("C3 >=", value, "c3");
            return (Criteria) this;
        }

        public Criteria andC3LessThan(String value) {
            addCriterion("C3 <", value, "c3");
            return (Criteria) this;
        }

        public Criteria andC3LessThanOrEqualTo(String value) {
            addCriterion("C3 <=", value, "c3");
            return (Criteria) this;
        }

        public Criteria andC3Like(String value) {
            addCriterion("C3 like", value, "c3");
            return (Criteria) this;
        }

        public Criteria andC3NotLike(String value) {
            addCriterion("C3 not like", value, "c3");
            return (Criteria) this;
        }

        public Criteria andC3In(List<String> values) {
            addCriterion("C3 in", values, "c3");
            return (Criteria) this;
        }

        public Criteria andC3NotIn(List<String> values) {
            addCriterion("C3 not in", values, "c3");
            return (Criteria) this;
        }

        public Criteria andC3Between(String value1, String value2) {
            addCriterion("C3 between", value1, value2, "c3");
            return (Criteria) this;
        }

        public Criteria andC3NotBetween(String value1, String value2) {
            addCriterion("C3 not between", value1, value2, "c3");
            return (Criteria) this;
        }

        public Criteria andC4IsNull() {
            addCriterion("C4 is null");
            return (Criteria) this;
        }

        public Criteria andC4IsNotNull() {
            addCriterion("C4 is not null");
            return (Criteria) this;
        }

        public Criteria andC4EqualTo(String value) {
            addCriterion("C4 =", value, "c4");
            return (Criteria) this;
        }

        public Criteria andC4NotEqualTo(String value) {
            addCriterion("C4 <>", value, "c4");
            return (Criteria) this;
        }

        public Criteria andC4GreaterThan(String value) {
            addCriterion("C4 >", value, "c4");
            return (Criteria) this;
        }

        public Criteria andC4GreaterThanOrEqualTo(String value) {
            addCriterion("C4 >=", value, "c4");
            return (Criteria) this;
        }

        public Criteria andC4LessThan(String value) {
            addCriterion("C4 <", value, "c4");
            return (Criteria) this;
        }

        public Criteria andC4LessThanOrEqualTo(String value) {
            addCriterion("C4 <=", value, "c4");
            return (Criteria) this;
        }

        public Criteria andC4Like(String value) {
            addCriterion("C4 like", value, "c4");
            return (Criteria) this;
        }

        public Criteria andC4NotLike(String value) {
            addCriterion("C4 not like", value, "c4");
            return (Criteria) this;
        }

        public Criteria andC4In(List<String> values) {
            addCriterion("C4 in", values, "c4");
            return (Criteria) this;
        }

        public Criteria andC4NotIn(List<String> values) {
            addCriterion("C4 not in", values, "c4");
            return (Criteria) this;
        }

        public Criteria andC4Between(String value1, String value2) {
            addCriterion("C4 between", value1, value2, "c4");
            return (Criteria) this;
        }

        public Criteria andC4NotBetween(String value1, String value2) {
            addCriterion("C4 not between", value1, value2, "c4");
            return (Criteria) this;
        }

        public Criteria andC5IsNull() {
            addCriterion("C5 is null");
            return (Criteria) this;
        }

        public Criteria andC5IsNotNull() {
            addCriterion("C5 is not null");
            return (Criteria) this;
        }

        public Criteria andC5EqualTo(String value) {
            addCriterion("C5 =", value, "c5");
            return (Criteria) this;
        }

        public Criteria andC5NotEqualTo(String value) {
            addCriterion("C5 <>", value, "c5");
            return (Criteria) this;
        }

        public Criteria andC5GreaterThan(String value) {
            addCriterion("C5 >", value, "c5");
            return (Criteria) this;
        }

        public Criteria andC5GreaterThanOrEqualTo(String value) {
            addCriterion("C5 >=", value, "c5");
            return (Criteria) this;
        }

        public Criteria andC5LessThan(String value) {
            addCriterion("C5 <", value, "c5");
            return (Criteria) this;
        }

        public Criteria andC5LessThanOrEqualTo(String value) {
            addCriterion("C5 <=", value, "c5");
            return (Criteria) this;
        }

        public Criteria andC5Like(String value) {
            addCriterion("C5 like", value, "c5");
            return (Criteria) this;
        }

        public Criteria andC5NotLike(String value) {
            addCriterion("C5 not like", value, "c5");
            return (Criteria) this;
        }

        public Criteria andC5In(List<String> values) {
            addCriterion("C5 in", values, "c5");
            return (Criteria) this;
        }

        public Criteria andC5NotIn(List<String> values) {
            addCriterion("C5 not in", values, "c5");
            return (Criteria) this;
        }

        public Criteria andC5Between(String value1, String value2) {
            addCriterion("C5 between", value1, value2, "c5");
            return (Criteria) this;
        }

        public Criteria andC5NotBetween(String value1, String value2) {
            addCriterion("C5 not between", value1, value2, "c5");
            return (Criteria) this;
        }

        public Criteria andC6IsNull() {
            addCriterion("C6 is null");
            return (Criteria) this;
        }

        public Criteria andC6IsNotNull() {
            addCriterion("C6 is not null");
            return (Criteria) this;
        }

        public Criteria andC6EqualTo(String value) {
            addCriterion("C6 =", value, "c6");
            return (Criteria) this;
        }

        public Criteria andC6NotEqualTo(String value) {
            addCriterion("C6 <>", value, "c6");
            return (Criteria) this;
        }

        public Criteria andC6GreaterThan(String value) {
            addCriterion("C6 >", value, "c6");
            return (Criteria) this;
        }

        public Criteria andC6GreaterThanOrEqualTo(String value) {
            addCriterion("C6 >=", value, "c6");
            return (Criteria) this;
        }

        public Criteria andC6LessThan(String value) {
            addCriterion("C6 <", value, "c6");
            return (Criteria) this;
        }

        public Criteria andC6LessThanOrEqualTo(String value) {
            addCriterion("C6 <=", value, "c6");
            return (Criteria) this;
        }

        public Criteria andC6Like(String value) {
            addCriterion("C6 like", value, "c6");
            return (Criteria) this;
        }

        public Criteria andC6NotLike(String value) {
            addCriterion("C6 not like", value, "c6");
            return (Criteria) this;
        }

        public Criteria andC6In(List<String> values) {
            addCriterion("C6 in", values, "c6");
            return (Criteria) this;
        }

        public Criteria andC6NotIn(List<String> values) {
            addCriterion("C6 not in", values, "c6");
            return (Criteria) this;
        }

        public Criteria andC6Between(String value1, String value2) {
            addCriterion("C6 between", value1, value2, "c6");
            return (Criteria) this;
        }

        public Criteria andC6NotBetween(String value1, String value2) {
            addCriterion("C6 not between", value1, value2, "c6");
            return (Criteria) this;
        }

        public Criteria andC7IsNull() {
            addCriterion("C7 is null");
            return (Criteria) this;
        }

        public Criteria andC7IsNotNull() {
            addCriterion("C7 is not null");
            return (Criteria) this;
        }

        public Criteria andC7EqualTo(String value) {
            addCriterion("C7 =", value, "c7");
            return (Criteria) this;
        }

        public Criteria andC7NotEqualTo(String value) {
            addCriterion("C7 <>", value, "c7");
            return (Criteria) this;
        }

        public Criteria andC7GreaterThan(String value) {
            addCriterion("C7 >", value, "c7");
            return (Criteria) this;
        }

        public Criteria andC7GreaterThanOrEqualTo(String value) {
            addCriterion("C7 >=", value, "c7");
            return (Criteria) this;
        }

        public Criteria andC7LessThan(String value) {
            addCriterion("C7 <", value, "c7");
            return (Criteria) this;
        }

        public Criteria andC7LessThanOrEqualTo(String value) {
            addCriterion("C7 <=", value, "c7");
            return (Criteria) this;
        }

        public Criteria andC7Like(String value) {
            addCriterion("C7 like", value, "c7");
            return (Criteria) this;
        }

        public Criteria andC7NotLike(String value) {
            addCriterion("C7 not like", value, "c7");
            return (Criteria) this;
        }

        public Criteria andC7In(List<String> values) {
            addCriterion("C7 in", values, "c7");
            return (Criteria) this;
        }

        public Criteria andC7NotIn(List<String> values) {
            addCriterion("C7 not in", values, "c7");
            return (Criteria) this;
        }

        public Criteria andC7Between(String value1, String value2) {
            addCriterion("C7 between", value1, value2, "c7");
            return (Criteria) this;
        }

        public Criteria andC7NotBetween(String value1, String value2) {
            addCriterion("C7 not between", value1, value2, "c7");
            return (Criteria) this;
        }

        public Criteria andC8IsNull() {
            addCriterion("C8 is null");
            return (Criteria) this;
        }

        public Criteria andC8IsNotNull() {
            addCriterion("C8 is not null");
            return (Criteria) this;
        }

        public Criteria andC8EqualTo(String value) {
            addCriterion("C8 =", value, "c8");
            return (Criteria) this;
        }

        public Criteria andC8NotEqualTo(String value) {
            addCriterion("C8 <>", value, "c8");
            return (Criteria) this;
        }

        public Criteria andC8GreaterThan(String value) {
            addCriterion("C8 >", value, "c8");
            return (Criteria) this;
        }

        public Criteria andC8GreaterThanOrEqualTo(String value) {
            addCriterion("C8 >=", value, "c8");
            return (Criteria) this;
        }

        public Criteria andC8LessThan(String value) {
            addCriterion("C8 <", value, "c8");
            return (Criteria) this;
        }

        public Criteria andC8LessThanOrEqualTo(String value) {
            addCriterion("C8 <=", value, "c8");
            return (Criteria) this;
        }

        public Criteria andC8Like(String value) {
            addCriterion("C8 like", value, "c8");
            return (Criteria) this;
        }

        public Criteria andC8NotLike(String value) {
            addCriterion("C8 not like", value, "c8");
            return (Criteria) this;
        }

        public Criteria andC8In(List<String> values) {
            addCriterion("C8 in", values, "c8");
            return (Criteria) this;
        }

        public Criteria andC8NotIn(List<String> values) {
            addCriterion("C8 not in", values, "c8");
            return (Criteria) this;
        }

        public Criteria andC8Between(String value1, String value2) {
            addCriterion("C8 between", value1, value2, "c8");
            return (Criteria) this;
        }

        public Criteria andC8NotBetween(String value1, String value2) {
            addCriterion("C8 not between", value1, value2, "c8");
            return (Criteria) this;
        }

        public Criteria andC9IsNull() {
            addCriterion("C9 is null");
            return (Criteria) this;
        }

        public Criteria andC9IsNotNull() {
            addCriterion("C9 is not null");
            return (Criteria) this;
        }

        public Criteria andC9EqualTo(String value) {
            addCriterion("C9 =", value, "c9");
            return (Criteria) this;
        }

        public Criteria andC9NotEqualTo(String value) {
            addCriterion("C9 <>", value, "c9");
            return (Criteria) this;
        }

        public Criteria andC9GreaterThan(String value) {
            addCriterion("C9 >", value, "c9");
            return (Criteria) this;
        }

        public Criteria andC9GreaterThanOrEqualTo(String value) {
            addCriterion("C9 >=", value, "c9");
            return (Criteria) this;
        }

        public Criteria andC9LessThan(String value) {
            addCriterion("C9 <", value, "c9");
            return (Criteria) this;
        }

        public Criteria andC9LessThanOrEqualTo(String value) {
            addCriterion("C9 <=", value, "c9");
            return (Criteria) this;
        }

        public Criteria andC9Like(String value) {
            addCriterion("C9 like", value, "c9");
            return (Criteria) this;
        }

        public Criteria andC9NotLike(String value) {
            addCriterion("C9 not like", value, "c9");
            return (Criteria) this;
        }

        public Criteria andC9In(List<String> values) {
            addCriterion("C9 in", values, "c9");
            return (Criteria) this;
        }

        public Criteria andC9NotIn(List<String> values) {
            addCriterion("C9 not in", values, "c9");
            return (Criteria) this;
        }

        public Criteria andC9Between(String value1, String value2) {
            addCriterion("C9 between", value1, value2, "c9");
            return (Criteria) this;
        }

        public Criteria andC9NotBetween(String value1, String value2) {
            addCriterion("C9 not between", value1, value2, "c9");
            return (Criteria) this;
        }

        public Criteria andC10IsNull() {
            addCriterion("C10 is null");
            return (Criteria) this;
        }

        public Criteria andC10IsNotNull() {
            addCriterion("C10 is not null");
            return (Criteria) this;
        }

        public Criteria andC10EqualTo(String value) {
            addCriterion("C10 =", value, "c10");
            return (Criteria) this;
        }

        public Criteria andC10NotEqualTo(String value) {
            addCriterion("C10 <>", value, "c10");
            return (Criteria) this;
        }

        public Criteria andC10GreaterThan(String value) {
            addCriterion("C10 >", value, "c10");
            return (Criteria) this;
        }

        public Criteria andC10GreaterThanOrEqualTo(String value) {
            addCriterion("C10 >=", value, "c10");
            return (Criteria) this;
        }

        public Criteria andC10LessThan(String value) {
            addCriterion("C10 <", value, "c10");
            return (Criteria) this;
        }

        public Criteria andC10LessThanOrEqualTo(String value) {
            addCriterion("C10 <=", value, "c10");
            return (Criteria) this;
        }

        public Criteria andC10Like(String value) {
            addCriterion("C10 like", value, "c10");
            return (Criteria) this;
        }

        public Criteria andC10NotLike(String value) {
            addCriterion("C10 not like", value, "c10");
            return (Criteria) this;
        }

        public Criteria andC10In(List<String> values) {
            addCriterion("C10 in", values, "c10");
            return (Criteria) this;
        }

        public Criteria andC10NotIn(List<String> values) {
            addCriterion("C10 not in", values, "c10");
            return (Criteria) this;
        }

        public Criteria andC10Between(String value1, String value2) {
            addCriterion("C10 between", value1, value2, "c10");
            return (Criteria) this;
        }

        public Criteria andC10NotBetween(String value1, String value2) {
            addCriterion("C10 not between", value1, value2, "c10");
            return (Criteria) this;
        }

        public Criteria andN1IsNull() {
            addCriterion("N1 is null");
            return (Criteria) this;
        }

        public Criteria andN1IsNotNull() {
            addCriterion("N1 is not null");
            return (Criteria) this;
        }

        public Criteria andN1EqualTo(BigDecimal value) {
            addCriterion("N1 =", value, "n1");
            return (Criteria) this;
        }

        public Criteria andN1NotEqualTo(BigDecimal value) {
            addCriterion("N1 <>", value, "n1");
            return (Criteria) this;
        }

        public Criteria andN1GreaterThan(BigDecimal value) {
            addCriterion("N1 >", value, "n1");
            return (Criteria) this;
        }

        public Criteria andN1GreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("N1 >=", value, "n1");
            return (Criteria) this;
        }

        public Criteria andN1LessThan(BigDecimal value) {
            addCriterion("N1 <", value, "n1");
            return (Criteria) this;
        }

        public Criteria andN1LessThanOrEqualTo(BigDecimal value) {
            addCriterion("N1 <=", value, "n1");
            return (Criteria) this;
        }

        public Criteria andN1In(List<BigDecimal> values) {
            addCriterion("N1 in", values, "n1");
            return (Criteria) this;
        }

        public Criteria andN1NotIn(List<BigDecimal> values) {
            addCriterion("N1 not in", values, "n1");
            return (Criteria) this;
        }

        public Criteria andN1Between(BigDecimal value1, BigDecimal value2) {
            addCriterion("N1 between", value1, value2, "n1");
            return (Criteria) this;
        }

        public Criteria andN1NotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("N1 not between", value1, value2, "n1");
            return (Criteria) this;
        }

        public Criteria andN2IsNull() {
            addCriterion("N2 is null");
            return (Criteria) this;
        }

        public Criteria andN2IsNotNull() {
            addCriterion("N2 is not null");
            return (Criteria) this;
        }

        public Criteria andN2EqualTo(BigDecimal value) {
            addCriterion("N2 =", value, "n2");
            return (Criteria) this;
        }

        public Criteria andN2NotEqualTo(BigDecimal value) {
            addCriterion("N2 <>", value, "n2");
            return (Criteria) this;
        }

        public Criteria andN2GreaterThan(BigDecimal value) {
            addCriterion("N2 >", value, "n2");
            return (Criteria) this;
        }

        public Criteria andN2GreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("N2 >=", value, "n2");
            return (Criteria) this;
        }

        public Criteria andN2LessThan(BigDecimal value) {
            addCriterion("N2 <", value, "n2");
            return (Criteria) this;
        }

        public Criteria andN2LessThanOrEqualTo(BigDecimal value) {
            addCriterion("N2 <=", value, "n2");
            return (Criteria) this;
        }

        public Criteria andN2In(List<BigDecimal> values) {
            addCriterion("N2 in", values, "n2");
            return (Criteria) this;
        }

        public Criteria andN2NotIn(List<BigDecimal> values) {
            addCriterion("N2 not in", values, "n2");
            return (Criteria) this;
        }

        public Criteria andN2Between(BigDecimal value1, BigDecimal value2) {
            addCriterion("N2 between", value1, value2, "n2");
            return (Criteria) this;
        }

        public Criteria andN2NotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("N2 not between", value1, value2, "n2");
            return (Criteria) this;
        }

        public Criteria andN3IsNull() {
            addCriterion("N3 is null");
            return (Criteria) this;
        }

        public Criteria andN3IsNotNull() {
            addCriterion("N3 is not null");
            return (Criteria) this;
        }

        public Criteria andN3EqualTo(BigDecimal value) {
            addCriterion("N3 =", value, "n3");
            return (Criteria) this;
        }

        public Criteria andN3NotEqualTo(BigDecimal value) {
            addCriterion("N3 <>", value, "n3");
            return (Criteria) this;
        }

        public Criteria andN3GreaterThan(BigDecimal value) {
            addCriterion("N3 >", value, "n3");
            return (Criteria) this;
        }

        public Criteria andN3GreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("N3 >=", value, "n3");
            return (Criteria) this;
        }

        public Criteria andN3LessThan(BigDecimal value) {
            addCriterion("N3 <", value, "n3");
            return (Criteria) this;
        }

        public Criteria andN3LessThanOrEqualTo(BigDecimal value) {
            addCriterion("N3 <=", value, "n3");
            return (Criteria) this;
        }

        public Criteria andN3In(List<BigDecimal> values) {
            addCriterion("N3 in", values, "n3");
            return (Criteria) this;
        }

        public Criteria andN3NotIn(List<BigDecimal> values) {
            addCriterion("N3 not in", values, "n3");
            return (Criteria) this;
        }

        public Criteria andN3Between(BigDecimal value1, BigDecimal value2) {
            addCriterion("N3 between", value1, value2, "n3");
            return (Criteria) this;
        }

        public Criteria andN3NotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("N3 not between", value1, value2, "n3");
            return (Criteria) this;
        }

        public Criteria andT1IsNull() {
            addCriterion("T1 is null");
            return (Criteria) this;
        }

        public Criteria andT1IsNotNull() {
            addCriterion("T1 is not null");
            return (Criteria) this;
        }

        public Criteria andT1EqualTo(Date value) {
            addCriterion("T1 =", value, "t1");
            return (Criteria) this;
        }

        public Criteria andT1NotEqualTo(Date value) {
            addCriterion("T1 <>", value, "t1");
            return (Criteria) this;
        }

        public Criteria andT1GreaterThan(Date value) {
            addCriterion("T1 >", value, "t1");
            return (Criteria) this;
        }

        public Criteria andT1GreaterThanOrEqualTo(Date value) {
            addCriterion("T1 >=", value, "t1");
            return (Criteria) this;
        }

        public Criteria andT1LessThan(Date value) {
            addCriterion("T1 <", value, "t1");
            return (Criteria) this;
        }

        public Criteria andT1LessThanOrEqualTo(Date value) {
            addCriterion("T1 <=", value, "t1");
            return (Criteria) this;
        }

        public Criteria andT1In(List<Date> values) {
            addCriterion("T1 in", values, "t1");
            return (Criteria) this;
        }

        public Criteria andT1NotIn(List<Date> values) {
            addCriterion("T1 not in", values, "t1");
            return (Criteria) this;
        }

        public Criteria andT1Between(Date value1, Date value2) {
            addCriterion("T1 between", value1, value2, "t1");
            return (Criteria) this;
        }

        public Criteria andT1NotBetween(Date value1, Date value2) {
            addCriterion("T1 not between", value1, value2, "t1");
            return (Criteria) this;
        }

        public Criteria andT2IsNull() {
            addCriterion("T2 is null");
            return (Criteria) this;
        }

        public Criteria andT2IsNotNull() {
            addCriterion("T2 is not null");
            return (Criteria) this;
        }

        public Criteria andT2EqualTo(Date value) {
            addCriterion("T2 =", value, "t2");
            return (Criteria) this;
        }

        public Criteria andT2NotEqualTo(Date value) {
            addCriterion("T2 <>", value, "t2");
            return (Criteria) this;
        }

        public Criteria andT2GreaterThan(Date value) {
            addCriterion("T2 >", value, "t2");
            return (Criteria) this;
        }

        public Criteria andT2GreaterThanOrEqualTo(Date value) {
            addCriterion("T2 >=", value, "t2");
            return (Criteria) this;
        }

        public Criteria andT2LessThan(Date value) {
            addCriterion("T2 <", value, "t2");
            return (Criteria) this;
        }

        public Criteria andT2LessThanOrEqualTo(Date value) {
            addCriterion("T2 <=", value, "t2");
            return (Criteria) this;
        }

        public Criteria andT2In(List<Date> values) {
            addCriterion("T2 in", values, "t2");
            return (Criteria) this;
        }

        public Criteria andT2NotIn(List<Date> values) {
            addCriterion("T2 not in", values, "t2");
            return (Criteria) this;
        }

        public Criteria andT2Between(Date value1, Date value2) {
            addCriterion("T2 between", value1, value2, "t2");
            return (Criteria) this;
        }

        public Criteria andT2NotBetween(Date value1, Date value2) {
            addCriterion("T2 not between", value1, value2, "t2");
            return (Criteria) this;
        }

        public Criteria andT3IsNull() {
            addCriterion("T3 is null");
            return (Criteria) this;
        }

        public Criteria andT3IsNotNull() {
            addCriterion("T3 is not null");
            return (Criteria) this;
        }

        public Criteria andT3EqualTo(Date value) {
            addCriterion("T3 =", value, "t3");
            return (Criteria) this;
        }

        public Criteria andT3NotEqualTo(Date value) {
            addCriterion("T3 <>", value, "t3");
            return (Criteria) this;
        }

        public Criteria andT3GreaterThan(Date value) {
            addCriterion("T3 >", value, "t3");
            return (Criteria) this;
        }

        public Criteria andT3GreaterThanOrEqualTo(Date value) {
            addCriterion("T3 >=", value, "t3");
            return (Criteria) this;
        }

        public Criteria andT3LessThan(Date value) {
            addCriterion("T3 <", value, "t3");
            return (Criteria) this;
        }

        public Criteria andT3LessThanOrEqualTo(Date value) {
            addCriterion("T3 <=", value, "t3");
            return (Criteria) this;
        }

        public Criteria andT3In(List<Date> values) {
            addCriterion("T3 in", values, "t3");
            return (Criteria) this;
        }

        public Criteria andT3NotIn(List<Date> values) {
            addCriterion("T3 not in", values, "t3");
            return (Criteria) this;
        }

        public Criteria andT3Between(Date value1, Date value2) {
            addCriterion("T3 between", value1, value2, "t3");
            return (Criteria) this;
        }

        public Criteria andT3NotBetween(Date value1, Date value2) {
            addCriterion("T3 not between", value1, value2, "t3");
            return (Criteria) this;
        }

        public Criteria andT4IsNull() {
            addCriterion("T4 is null");
            return (Criteria) this;
        }

        public Criteria andT4IsNotNull() {
            addCriterion("T4 is not null");
            return (Criteria) this;
        }

        public Criteria andT4EqualTo(Date value) {
            addCriterion("T4 =", value, "t4");
            return (Criteria) this;
        }

        public Criteria andT4NotEqualTo(Date value) {
            addCriterion("T4 <>", value, "t4");
            return (Criteria) this;
        }

        public Criteria andT4GreaterThan(Date value) {
            addCriterion("T4 >", value, "t4");
            return (Criteria) this;
        }

        public Criteria andT4GreaterThanOrEqualTo(Date value) {
            addCriterion("T4 >=", value, "t4");
            return (Criteria) this;
        }

        public Criteria andT4LessThan(Date value) {
            addCriterion("T4 <", value, "t4");
            return (Criteria) this;
        }

        public Criteria andT4LessThanOrEqualTo(Date value) {
            addCriterion("T4 <=", value, "t4");
            return (Criteria) this;
        }

        public Criteria andT4In(List<Date> values) {
            addCriterion("T4 in", values, "t4");
            return (Criteria) this;
        }

        public Criteria andT4NotIn(List<Date> values) {
            addCriterion("T4 not in", values, "t4");
            return (Criteria) this;
        }

        public Criteria andT4Between(Date value1, Date value2) {
            addCriterion("T4 between", value1, value2, "t4");
            return (Criteria) this;
        }

        public Criteria andT4NotBetween(Date value1, Date value2) {
            addCriterion("T4 not between", value1, value2, "t4");
            return (Criteria) this;
        }

        public Criteria andT5IsNull() {
            addCriterion("T5 is null");
            return (Criteria) this;
        }

        public Criteria andT5IsNotNull() {
            addCriterion("T5 is not null");
            return (Criteria) this;
        }

        public Criteria andT5EqualTo(Date value) {
            addCriterion("T5 =", value, "t5");
            return (Criteria) this;
        }

        public Criteria andT5NotEqualTo(Date value) {
            addCriterion("T5 <>", value, "t5");
            return (Criteria) this;
        }

        public Criteria andT5GreaterThan(Date value) {
            addCriterion("T5 >", value, "t5");
            return (Criteria) this;
        }

        public Criteria andT5GreaterThanOrEqualTo(Date value) {
            addCriterion("T5 >=", value, "t5");
            return (Criteria) this;
        }

        public Criteria andT5LessThan(Date value) {
            addCriterion("T5 <", value, "t5");
            return (Criteria) this;
        }

        public Criteria andT5LessThanOrEqualTo(Date value) {
            addCriterion("T5 <=", value, "t5");
            return (Criteria) this;
        }

        public Criteria andT5In(List<Date> values) {
            addCriterion("T5 in", values, "t5");
            return (Criteria) this;
        }

        public Criteria andT5NotIn(List<Date> values) {
            addCriterion("T5 not in", values, "t5");
            return (Criteria) this;
        }

        public Criteria andT5Between(Date value1, Date value2) {
            addCriterion("T5 between", value1, value2, "t5");
            return (Criteria) this;
        }

        public Criteria andT5NotBetween(Date value1, Date value2) {
            addCriterion("T5 not between", value1, value2, "t5");
            return (Criteria) this;
        }

        public Criteria andT6IsNull() {
            addCriterion("T6 is null");
            return (Criteria) this;
        }

        public Criteria andT6IsNotNull() {
            addCriterion("T6 is not null");
            return (Criteria) this;
        }

        public Criteria andT6EqualTo(Date value) {
            addCriterion("T6 =", value, "t6");
            return (Criteria) this;
        }

        public Criteria andT6NotEqualTo(Date value) {
            addCriterion("T6 <>", value, "t6");
            return (Criteria) this;
        }

        public Criteria andT6GreaterThan(Date value) {
            addCriterion("T6 >", value, "t6");
            return (Criteria) this;
        }

        public Criteria andT6GreaterThanOrEqualTo(Date value) {
            addCriterion("T6 >=", value, "t6");
            return (Criteria) this;
        }

        public Criteria andT6LessThan(Date value) {
            addCriterion("T6 <", value, "t6");
            return (Criteria) this;
        }

        public Criteria andT6LessThanOrEqualTo(Date value) {
            addCriterion("T6 <=", value, "t6");
            return (Criteria) this;
        }

        public Criteria andT6In(List<Date> values) {
            addCriterion("T6 in", values, "t6");
            return (Criteria) this;
        }

        public Criteria andT6NotIn(List<Date> values) {
            addCriterion("T6 not in", values, "t6");
            return (Criteria) this;
        }

        public Criteria andT6Between(Date value1, Date value2) {
            addCriterion("T6 between", value1, value2, "t6");
            return (Criteria) this;
        }

        public Criteria andT6NotBetween(Date value1, Date value2) {
            addCriterion("T6 not between", value1, value2, "t6");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}